//********************************************
// LCD Display Liblary          by r.nanbu
//********************************************

//              <default>
// LCDPORT	    8:|[gW	ڑ|[g͕Kݒ肷邱
// LCD_SCROLL   0:sȂ	XN[\sꍇ͐ݒ肷
// LCDMAX_X    16:16		@@@@V
// LCDMAX_Y     2: 2s      	        V
// LCDMAX_BUF  16: 2s         		V
//              		ݒ肷邱

// ύX
// 2003/10/10 œKxPɑΉixOgpsj
// 2003/04/22 ŉʂ̌ɐȊŐL\̂C
// 2003/04/18 LCDo̓|[gB7,B6𑀍삵Ȃ悤ɂ
// 2002/06/18 XN[֘Aϐ`ꏊύX
//            LCDMAX_BUF ftHglύX(302)
// 2002/06/12 CursorOn/Off ֐̕ύX
// 2002/06/04 LCD֘AOݒ\ɂ
// 2002/05/30 obNXN[֐ǉ
// 2002/05/28 XN[ǉis'\n')
// 2002/05/20 _ȏオOƂȂꍇ̕sC
// 2002/05/08 
//********************************************

#include <3664.h>



//********************************************
//********* @ȉ̓ftHgݒ@ *********

// LCD̐ڑ|[g͕KmF
// LCD̐ڑ|[g(P8܂P5)̔ԍݒ
#ifndef LCDPORT
#define LCDPORT 8
#endif
// ȉ̓XN[\ݒ
// LCD̃XN[ېݒ(XN[@1: 0:Ȃ)
#ifndef LCD_SCROLL
#define LCD_SCROLL 0
#endif
// XN[\ꍇ͈ȉݒ
// LCD̉̕\͈͂ݒ(1-20)
#ifndef LCDMAX_X
#define LCDMAX_X 16
#endif
// LCD̏c̕\͈͂ݒ(1-4)
#ifndef LCDMAX_Y
#define LCDMAX_Y 2
#endif
// LCD̃obNXN[\Ls(LCDMAX_Y ȏ)
#ifndef LCDMAX_BUF
#define LCDMAX_BUF 2
#endif



//********************************************
//********** @LCD\{֐@ @ **********

// ́@2.31us ҂֐ 
void _Wait505ns(int tm) 
{
  int i;
  for (i=0 ; i<tm ; i++) ;
}

// ́@1ms ҂֐
void _Wait1ms(int tm)
{
  int i;
  for (i=0 ; i<tm ; i++) _Wait505ns(1980);
}

// SrbgR}ho 
void _CmdOut(unsigned char dt)  
{
  _Wait505ns(20);
  switch (LCDPORT)
  {
    case 8: IO.PDR8.BYTE=dt | (IO.PDR8.BYTE & 0xc0);
            _Wait505ns(20);
            IO.PDR8.BIT.B5=1;
            _Wait505ns(20);
            IO.PDR8.BIT.B5=0;
            break;
    case 5: IO.PDR5.BYTE=dt | (IO.PDR5.BYTE & 0xc0);
            _Wait505ns(20);
            IO.PDR5.BIT.B5=1;
            _Wait505ns(20);
            IO.PDR5.BIT.B5=0;
            break;
  }
  _Wait505ns(20);
}

// CXgNVo 
void _CommandOut(unsigned char dt) 
{
  _CmdOut((dt>>4) & 0x0f);
  _CmdOut(dt & 0x0f);
}

// Srbgf[^o 
void _DatOut(unsigned char dt)  
{
  _Wait505ns(20);
  switch (LCDPORT)
  {
    case 8: IO.PDR8.BYTE=(dt | 0x10) | (IO.PDR8.BYTE & 0xc0);
            _Wait505ns(20);
            IO.PDR8.BIT.B5=1;
            _Wait505ns(5);
            IO.PDR8.BIT.B5=0;
            break;
    case 5: IO.PDR5.BYTE=(dt | 0x10) | (IO.PDR5.BYTE & 0xc0);
            _Wait505ns(20);
            IO.PDR5.BIT.B5=1;
            _Wait505ns(5);
            IO.PDR5.BIT.B5=0;
            break;
  }
  _Wait505ns(20);
}


#if LCD_SCROLL
//********************************************
//************ XN[菈 ************
//********************************************


//*****  LCDXN[}Nϐ` *****

#define _Y(a) ((_y0place + (a)) % LCDMAX_BUF)

// LCDXN[ϐ`
char _lcdbuf[LCDMAX_BUF][LCDMAX_X+1];
int _x=0;       //LCDxW
int _y=0;       //LCDyW
int _y0place=0; //\ݎLCDBUF̍sʒu

int _area=0;    //0:XN[GAA 1:OGA
int _scroll=0;  //0:\Ȃ珑݁A1:obNXN[\A\
int _sy0place=0; //XN[\LCDBUF̍sʒu



// ꕶ(AsciiR[h)o͕\ 
void _CharactorOut(char dt)  
{
  _DatOut((dt>>4) & 0x0f);
  _DatOut(dt & 0x0f);
}

// J[\\ʒuݒ(ys[j 
void _Locate(int y) 
{
  if (y<2)
    _CommandOut(0x80 + y * 0x40);
  else
    _CommandOut(0x80 + (y-2) * 0x40 + 0x14);
}

//XN[GAf[^NA
void _ClearScrollData(void)
{
  int i;
  _x=0;
  _y=0;
  _y0place=0;
  _scroll=0;
  for (i=0 ; i<LCDMAX_BUF ; i++)
    _lcdbuf[i][0]='\n';
}

//XN[GA\NAi\̂݁j
void _ClearScrollArea(void)
{
  int x,y;
  
  for (y=0 ; y<LCDMAX_Y ; y++)
    {
      _Locate(y);
      for (x=0 ; x<LCDMAX_X ; x++)
      {
        _CharactorOut(' ');       //󔒏o
      }
    }
}

// J[\\ʒuݒ(x=0,y=0j 
void Locate(int x,int y) 
{
  //XN[GAł Locate(x,y) ͒ÕJ[\ʒuݒƂȂ
  //XN[GAOł͒ʏ̓
  if (x<LCDMAX_X && y<LCDMAX_Y)
  {
    x=_x;
    y=_y;
    _area=0;
  }
  else
    _area=1;
  
  if (y<2)
    _CommandOut(0x80 + y * 0x40 + x);
  else
    _CommandOut(0x80 + (y-2) * 0x40 + x + 0x14);
}

// \NA { J[\z[(jړ 
void ClearScreen(void) 
{
  _ClearScrollData();
  _CommandOut(0x01);
  _Wait1ms(100);
}

// ꕶ(AsciiR[h)o͕\ 
void CharactorOut(char dt)  
{
  int x,y;
  
  if (dt!='\n' && (_scroll==0 || _area==1))
  {
    _CharactorOut(dt);       //o
  }
  
  //XN[GAł΃XN[
  if (_area==0)
  {
    _lcdbuf[_Y(_y)][_x]=dt;
    _x++;
    if (_x==LCDMAX_X || dt=='\n')
    {
      _lcdbuf[_Y(_y)][LCDMAX_X]='\n';
      _x=0;
      _y++;
      if (_y == LCDMAX_Y)
      {
        _y0place++;
        if (_y0place == LCDMAX_BUF) _y0place=0;
        
        //ʏ폑ݒł΁A\
        if (_scroll==0) 
        {
          _sy0place=_y0place;
          _ClearScrollArea();          //XN[GA\NA
          _CommandOut(0x0C);           //J[\\
          for (y=0 ; y<(LCDMAX_Y-1) ; y++)
          {
            _Locate(y);
            for (x=0 ; (dt=_lcdbuf[_Y(y)][x])!='\n' ; x++)
            {
              _CharactorOut(dt);       //o
            }
          }
          _CommandOut(0x0E);           //J[\\
        }
        _y=LCDMAX_Y-1;
      }
      _Locate(_y);
    }
  }
}

//obNXN[\
int BackScrollDisplay(int p)
{
  int x,y;
  char dt;
  int endflg=1;

  _ClearScrollArea();           //XN[GA\NA
  _CommandOut(0x0C);           //J[\\

  //obNXN[I
  if (p==0)
  {
    _scroll=0;                 //XN[\iʏ폈j
    _sy0place=_y0place;

    for (y=0 ; y<(LCDMAX_Y-1) ; y++)
    {
      _Locate(y);
      for (x=0 ; (dt=_lcdbuf[_Y(y)][x])!='\n' ; x++)
      {
        _CharactorOut(dt);       //o
      }
    }
    _Locate(y);
    for (x=0 ; x<_x ; x++)
    {
      dt=_lcdbuf[_Y(y)][x];
      _CharactorOut(dt);       //o
    }
  }
  //obNXN[\
  else
  {
    _scroll=1;

    _sy0place+=(p+LCDMAX_BUF);
    _sy0place%=LCDMAX_BUF;
    for (y=0 ; y<(LCDMAX_Y) ; y++)
    {
      char yy;
      _Locate(y);
      yy=(_sy0place + y) % LCDMAX_BUF;
      if (yy==(_y0place + LCDMAX_Y)) endflg=0;
      for (x=0 ; (dt=_lcdbuf[yy][x]) != '\n' ; x++)
      {
        _CharactorOut(dt);       //o
      }
    }
  }
  _CommandOut(0x0E);           //J[\\
  return endflg;
}


#else
//********************************************
//************ XN[Ȃ ************
//
// \NA { J[\z[(jړ 
void ClearScreen(void) 
{
  _CommandOut(0x01);
  _Wait1ms(100);
}

// J[\\ʒuݒ(x=0,y=0j 
void Locate(int x,int y) 
{
  if (y<2)
    _CommandOut(0x80 + y * 0x40 + x);
  else
    _CommandOut(0x80 + (y-2) * 0x40 + x + 0x14);
}

// ꕶ(AsciiR[h)o͕\ 
void CharactorOut(char dt)  
{
  _DatOut((dt>>4) & 0x0f);
  _DatOut(dt & 0x0f);
}
#endif



//********************************************
//************ kbc֐@***************

// J[\\ 
void CursorOn(void)  
{
  _CommandOut(0x0E);
}

// J[\\ 
void CursorOff(void) 
{
  _CommandOut(0x0C);
}

// LCD 
void InitLCD(void) 
{
  switch (LCDPORT)
  {
    case 8:  IO.PCR8=0xff; break;
    case 5:  IO.PCR5=0xff; break;
  }
  _Wait1ms(200);
  _CmdOut(0x03);
  _Wait1ms(40);
  _CmdOut(0x03);
  _Wait1ms(1);
  _CmdOut(0x03);
  _CmdOut(0x02);

  _CommandOut(0x28); //Srbg
  _CommandOut(0x0f);
  _CommandOut(0x06);
  _CommandOut(0x01);

  _Wait1ms(100);
  ClearScreen();
}



//********************************************
//************ kbc\֐@***************

// o͕\ 
void StringOut(char *dt)  
{
  while(*dt)
  {
    CharactorOut(*dt);
    dt++;
  }
}

// \ 
void NumberOut(int number) 
{
  int i;
  int length;
  char w;
  char str[10];

  if (number<0)
  {
    CharactorOut('-');
    number*=-1;
  }
  for (i=0 ; i<10 ; i++)
  {
    str[i]='0'+(number % 10);
    number/=10;
    if (number==0) break;
  }
  length=i;
  str[length+1]='\0';

  for (i=0 ; i<(length+1)/2 ; i++)
  {
    w=str[i];
    str[i]=str[length-i];
    str[length-i]=w;
  }
  StringOut(str);
}

// \wAl\
void FormatNumberOut(float fnumber,int left, int right)
{
  int i;
  int length;
  int sign=0;
  long number;
  char w;
  char str[20];

  for (i=0 ; i<=right ; i++)
    fnumber*=10;
  number=fnumber;
  if (number<0)
  {
    sign=1;
    number*=-1;
  }
  number+=5;
  number/=10;
  for (i=0 ; i<15 ; i++)
  {
    if (i==right) str[i++]='.';
    str[i]='0'+number % 10;
    number/=10;
    if (i>right && number==0) break;
  }
  if (sign==1) str[++i]='-';
  for (i++ ;i<left+right+1;i++)
    str[i]=' ';
  length=i-1;
  str[i]='\0';
  for (i=0 ; i<(length+1)/2 ; i++)
  {
    w=str[i];
    str[i]=str[length-i];
    str[length-i]=w;
  }
  if (str[length]=='.') str[length]='\0';
  StringOut(str);
}

// \wAlQi\
void BNumberOut(int number,int keta)
{
  for (--keta ; keta>=0 ; keta--)
  {
     NumberOut(( ((unsigned int)number) >> keta) & 1);
  }
}

// \wAlPUi\
void HNumberOut(int number,int keta)
{
  int n;
  for (--keta ; keta>=0 ; keta--)
  {
    n=((unsigned int)number>>(keta*4)) & 0xf;
    if (n>9) n+=7;
    CharactorOut('0'+n);
  }
}

// kbceXg\
void TestDisplay(void)
{
  InitLCD();
  StringOut("LcdTest Success");
}
